//---------------------------------------------------------------------------

#include <fmx.h>
#include <System.Ioutils.hpp>
#pragma hdrstop

#include "Unit2.h"
#include "Fmx.BitmapUtil.hpp"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.fmx"
#pragma resource ("*.LgXhdpiPh.fmx", _PLAT_ANDROID)

TForm2 *Form2;
//---------------------------------------------------------------------------
__fastcall TForm2::TForm2(TComponent* Owner)
	: TForm(Owner)
{

	m_ScreenImage = new TImage(NULL);


		#if defined(_PLAT_ANDROID)
		_di_IFMXScreenService  ScreenService;
		if (TPlatformServices::Current->SupportsPlatformService(__uuidof(IFMXScreenService), &ScreenService))
		{
			m_ScreenScale =  ScreenService->GetScreenScale();
			m_ScreenPoint = ScreenService->GetScreenSize();
		}
		#else defined(_PLAT_MACOS) || defined(WIN32)
			m_ScreenPoint.X = this->Width;
			m_ScreenPoint.Y = this->Height;
		#endif
}
//---------------------------------------------------------------------------
void __fastcall TForm2::Button1Click(TObject *Sender)
{
	String bk;
	String a1;

	#if defined(_PLAT_ANDROID)
	bk = System::Ioutils::TPath::GetDocumentsPath() + System::Ioutils::TPath::DirectorySeparatorChar + L"bk-1.jpg";
	a1 = System::Ioutils::TPath::GetDocumentsPath() + System::Ioutils::TPath::DirectorySeparatorChar + L"icon-11.png";
	#else
	bk = _D("bk-1.jpg");
	a1 = _D("icon-11.png");;
	#endif

	bkimg = new TImage(NULL);
	bkimg->Bitmap->LoadFromFile(bk);

	i2 = new TImage(NULL);
	i2->Bitmap->LoadFromFile(a1);

	TImage *p = new TImage(NULL);
	p->Bitmap->SetSize(m_ScreenPoint.x,m_ScreenPoint.y);
	m_ScreenImage->Bitmap->SetSize(m_ScreenPoint.x,m_ScreenPoint.y);

    // Windows is OK  ,But Android is Failed
	p->Bitmap->Canvas->BeginScene();
	p->Bitmap->Canvas->Clear(claWhite);
	p->Bitmap->Canvas->DrawBitmap( bkimg->Bitmap,RectF(0, 0,bkimg->Bitmap->Width,bkimg->Bitmap->Height),RectF(0, 0,m_ScreenPoint.X,m_ScreenPoint.Y),1, true);
	p->Bitmap->Canvas->DrawBitmap( i2->Bitmap,RectF(0, 0,i2->Bitmap->Width,i2->Bitmap->Height),RectF(10,250,10+i2->Bitmap->Width,250+i2->Bitmap->Height),1, true);
	p->Bitmap->Canvas->EndScene();

	p->Bitmap->Canvas->BeginScene();
	m_ScreenImage->Bitmap->Canvas->BeginScene();
	m_ScreenImage->Bitmap->Assign(p->Bitmap);
	m_ScreenImage->Bitmap->Canvas->EndScene();
	delete p ;

	InvalidateRect(RectF(0, 0,m_ScreenPoint.X,m_ScreenPoint.Y));
}

void __fastcall TForm2::FormPaint(TObject *Sender, TCanvas *Canvas, const TRectF &ARect)
{
	Canvas->DrawBitmap(m_ScreenImage->Bitmap,TRectF(0,0,m_ScreenImage->Bitmap->Width,m_ScreenImage->Bitmap->Height),
		TRectF(0,0,m_ScreenPoint.X,m_ScreenPoint.Y),1);

}
//---------------------------------------------------------------------------

void __fastcall TForm2::Button2Click(TObject *Sender)
{
	String bk;
	String a1;

	bk = System::Ioutils::TPath::GetDocumentsPath() + System::Ioutils::TPath::DirectorySeparatorChar + L"bk-1.jpg";
	bkimg = new TImage(NULL);
	bkimg->Bitmap->LoadFromFile(bk);

	a1 = System::Ioutils::TPath::GetDocumentsPath() + System::Ioutils::TPath::DirectorySeparatorChar + L"icon-11.png";
	i2 = new TImage(NULL);
	i2->Bitmap->LoadFromFile(a1);

	TImage *p = new TImage(NULL);
	p->Bitmap->SetSize(m_ScreenPoint.x,m_ScreenPoint.y);
	m_ScreenImage->Bitmap->SetSize(m_ScreenPoint.x,m_ScreenPoint.y);

	#if defined(_PLAT_ANDROID)
	Fmx::Bitmaputil::MergeBitmap(i2->Bitmap,bkimg->Bitmap,TRect(0, 0,i2->Bitmap->Width,i2->Bitmap->Height),10,250);

	m_ScreenImage->Bitmap->Canvas->BeginScene();
	m_ScreenImage->Bitmap->Assign(bkimg->Bitmap);
	m_ScreenImage->Bitmap->Canvas->EndScene();
	#else
	p->Bitmap->Canvas->BeginScene();
	p->Bitmap->Canvas->Clear(claWhite);
	p->Bitmap->Canvas->DrawBitmap( bkimg->Bitmap,RectF(0, 0,bkimg->Bitmap->Width,bkimg->Bitmap->Height),RectF(0, 0,m_ScreenPoint.X,m_ScreenPoint.Y),1, true);
	p->Bitmap->Canvas->DrawBitmap( i2->Bitmap,RectF(0, 0,i2->Bitmap->Width,i2->Bitmap->Height),RectF(10,250,10+i2->Bitmap->Width,250+i2->Bitmap->Height),1, true);
	m_ScreenImage->Bitmap->Canvas->BeginScene();
	m_ScreenImage->Bitmap->Assign(p->Bitmap);
	m_ScreenImage->Bitmap->Canvas->EndScene();
	#endif
	delete p ;

	InvalidateRect(RectF(0, 0,m_ScreenPoint.X,m_ScreenPoint.Y));


}
//---------------------------------------------------------------------------

